import { defineComponent as U, ref as d, computed as s, watch as X, createElementBlock as o, openBlock as n, normalizeStyle as Y, unref as z, createCommentVNode as r, createElementVNode as u, normalizeClass as p, renderSlot as w, createTextVNode as g, toDisplayString as c, withKeys as Z, withModifiers as _, withDirectives as L, vShow as S } from "vue";
import { useInject as ee, useSlotsExist as te } from "../utils/index.js";
const ae = {
  key: 0,
  class: "input-prefix"
}, oe = ["type", "value", "placeholder", "maxlength", "disabled", "onKeydown"], ne = {
  key: 1,
  class: "input-suffix"
}, le = {
  class: "eye-svg",
  focusable: "false",
  "data-icon": "eye",
  width: "1em",
  height: "1em",
  fill: "currentColor",
  "aria-hidden": "true",
  viewBox: "64 64 896 896"
}, se = {
  class: "eye-svg",
  focusable: "false",
  "data-icon": "eye-invisible",
  width: "1em",
  height: "1em",
  fill: "currentColor",
  "aria-hidden": "true",
  viewBox: "64 64 896 896"
}, ue = {
  key: 2,
  class: "input-count"
}, ie = {
  key: 3,
  class: "suffix-item"
}, fe = /* @__PURE__ */ U({
  __name: "Input",
  props: {
    width: { default: "100%" },
    size: { default: "middle" },
    addonBefore: { default: void 0 },
    addonAfter: { default: void 0 },
    prefix: { default: void 0 },
    suffix: { default: void 0 },
    allowClear: { type: Boolean, default: !1 },
    password: { type: Boolean, default: !1 },
    disabled: { type: Boolean, default: !1 },
    placeholder: { default: void 0 },
    maxlength: { default: void 0 },
    showCount: { type: Boolean, default: !1 },
    value: { default: void 0 },
    valueModifiers: { default: () => ({}) }
  },
  emits: ["update:value", "compositionstart", "compositionend", "change", "enter"],
  setup(A, { emit: I }) {
    const a = A, B = d(null), y = d(!1), C = d(!1), v = d(!1), l = d(), f = d(!1), { colorPalettes: k, shadowColor: q } = ee("Input"), i = I, h = te(["prefix", "suffix", "addonBefore", "addonAfter"]), N = s(() => typeof a.width == "number" ? `${a.width}px` : a.width), E = s(() => !a.disabled && a.allowClear), P = s(() => a.maxlength ? `${l.value ? l.value.length : 0} / ${a.maxlength}` : l.value ? l.value.length : 0), V = s(() => h.prefix || a.prefix), M = s(() => h.suffix || a.suffix), K = s(() => E.value || a.password || a.showCount || M.value), x = s(() => h.addonBefore || a.addonBefore), b = s(() => h.addonAfter || a.addonAfter), $ = s(() => "lazy" in a.valueModifiers);
    X(
      () => a.value,
      (e) => {
        l.value !== e && (l.value = e);
      },
      {
        immediate: !0
      }
    );
    function Q() {
      y.value = !0;
    }
    function D() {
      y.value = !1;
    }
    function F() {
      C.value = !0;
    }
    function R() {
      C.value = !1;
    }
    function W(e) {
      v.value = !0, i("compositionstart", e);
    }
    function j(e) {
      var m;
      v.value = !1, i("compositionend", e);
      const t = new Event("change");
      (m = e.target) == null || m.dispatchEvent(t);
    }
    function H(e) {
      if (!v.value) {
        const t = e.target;
        l.value = t.value, $.value || (i("update:value", t.value), i("change", e));
      }
    }
    function T(e) {
      const t = e.target;
      t.value !== a.value && (i("update:value", t.value), i("change", e));
    }
    function G(e) {
      var t;
      if (!v.value && (i("enter", e), $.value)) {
        const m = new Event("change");
        (t = e.target) == null || t.dispatchEvent(m);
      }
    }
    function J() {
      var e;
      l.value = "", i("update:value", ""), (e = B.value) == null || e.focus();
    }
    function O() {
      f.value = !f.value;
    }
    return (e, t) => (n(), o("div", {
      class: "m-input",
      style: Y(`
      --input-width: ${N.value};
      --input-primary-color-hover: ${z(k)[4]};
      --input-primary-color-focus: ${z(k)[4]};
      --input-primary-shadow-color: ${z(q)};
    `)
    }, [
      x.value ? (n(), o("span", {
        key: 0,
        class: p(["input-addon", { "addon-before": x.value }])
      }, [
        w(e.$slots, "addonBefore", {}, () => [
          g(c(e.addonBefore), 1)
        ], !0)
      ], 2)) : r("", !0),
      u("div", {
        tabindex: "1",
        class: p(["input-wrap", [
          `input-${e.size}`,
          {
            "input-before": x.value,
            "input-after": b.value,
            "input-disabled": e.disabled
          }
        ]]),
        onMouseenter: Q,
        onMouseleave: D
      }, [
        t[3] || (t[3] = u("div", { class: "input-border" }, null, -1)),
        u("div", {
          class: p(["input-border-state", { "input-hover": y.value, "input-focus": C.value }])
        }, null, 2),
        V.value ? (n(), o("span", ae, [
          w(e.$slots, "prefix", {}, () => [
            g(c(e.prefix), 1)
          ], !0)
        ])) : r("", !0),
        u("input", {
          ref_key: "inputRef",
          ref: B,
          class: "input-item",
          type: e.password && !f.value ? "password" : "text",
          value: l.value,
          placeholder: e.placeholder,
          maxlength: e.maxlength,
          disabled: e.disabled,
          onFocus: F,
          onBlur: R,
          onCompositionstart: W,
          onCompositionend: j,
          onInput: H,
          onChange: T,
          onKeydown: Z(_(G, ["prevent"]), ["enter"])
        }, null, 40, oe),
        K.value ? (n(), o("span", ne, [
          E.value ? (n(), o("span", {
            key: 0,
            class: p(["input-actions", { "clear-hidden": !l.value }]),
            onClick: J
          }, t[0] || (t[0] = [
            u("svg", {
              class: "clear-svg",
              focusable: "false",
              "data-icon": "close-circle",
              width: "1em",
              height: "1em",
              fill: "currentColor",
              "aria-hidden": "true",
              viewBox: "64 64 896 896"
            }, [
              u("path", { d: "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448 448-200.6 448-448S759.4 64 512 64zm165.4 618.2l-66-.3L512 563.4l-99.3 118.4-66.1.3c-4.4 0-8-3.5-8-8 0-1.9.7-3.7 1.9-5.2l130.1-155L340.5 359a8.32 8.32 0 01-1.9-5.2c0-4.4 3.6-8 8-8l66.1.3L512 464.6l99.3-118.4 66-.3c4.4 0 8 3.5 8 8 0 1.9-.7 3.7-1.9 5.2L553.5 514l130 155c1.2 1.5 1.9 3.3 1.9 5.2 0 4.4-3.6 8-8 8z" })
            ], -1)
          ]), 2)) : r("", !0),
          e.password ? (n(), o("span", {
            key: 1,
            class: "input-actions",
            onClick: O
          }, [
            L((n(), o("svg", le, t[1] || (t[1] = [
              u("path", { d: "M942.2 486.2C847.4 286.5 704.1 186 512 186c-192.2 0-335.4 100.5-430.2 300.3a60.3 60.3 0 000 51.5C176.6 737.5 319.9 838 512 838c192.2 0 335.4-100.5 430.2-300.3 7.7-16.2 7.7-35 0-51.5zM512 766c-161.3 0-279.4-81.8-362.7-254C232.6 339.8 350.7 258 512 258c161.3 0 279.4 81.8 362.7 254C791.5 684.2 673.4 766 512 766zm-4-430c-97.2 0-176 78.8-176 176s78.8 176 176 176 176-78.8 176-176-78.8-176-176-176zm0 288c-61.9 0-112-50.1-112-112s50.1-112 112-112 112 50.1 112 112-50.1 112-112 112z" }, null, -1)
            ]), 512)), [
              [S, f.value]
            ]),
            L((n(), o("svg", se, t[2] || (t[2] = [
              u("path", { d: "M942.2 486.2Q889.47 375.11 816.7 305l-50.88 50.88C807.31 395.53 843.45 447.4 874.7 512 791.5 684.2 673.4 766 512 766q-72.67 0-133.87-22.38L323 798.75Q408 838 512 838q288.3 0 430.2-300.3a60.29 60.29 0 000-51.5zm-63.57-320.64L836 122.88a8 8 0 00-11.32 0L715.31 232.2Q624.86 186 512 186q-288.3 0-430.2 300.3a60.3 60.3 0 000 51.5q56.69 119.4 136.5 191.41L112.48 835a8 8 0 000 11.31L155.17 889a8 8 0 0011.31 0l712.15-712.12a8 8 0 000-11.32zM149.3 512C232.6 339.8 350.7 258 512 258c54.54 0 104.13 9.36 149.12 28.39l-70.3 70.3a176 176 0 00-238.13 238.13l-83.42 83.42C223.1 637.49 183.3 582.28 149.3 512zm246.7 0a112.11 112.11 0 01146.2-106.69L401.31 546.2A112 112 0 01396 512z" }, null, -1),
              u("path", { d: "M508 624c-3.46 0-6.87-.16-10.25-.47l-52.82 52.82a176.09 176.09 0 00227.42-227.42l-52.82 52.82c.31 3.38.47 6.79.47 10.25a111.94 111.94 0 01-112 112z" }, null, -1)
            ]), 512)), [
              [S, !f.value]
            ])
          ])) : r("", !0),
          e.showCount ? (n(), o("span", ue, c(P.value), 1)) : r("", !0),
          M.value ? (n(), o("span", ie, [
            w(e.$slots, "suffix", {}, () => [
              g(c(e.suffix), 1)
            ], !0)
          ])) : r("", !0)
        ])) : r("", !0)
      ], 34),
      b.value ? (n(), o("span", {
        key: 1,
        class: p(["input-addon", { "addon-after": b.value }])
      }, [
        w(e.$slots, "addonAfter", {}, () => [
          g(c(e.addonAfter), 1)
        ], !0)
      ], 2)) : r("", !0)
    ], 4));
  }
});
export {
  fe as default
};
