import { defineComponent as A, ref as w, computed as s, watch as F, createElementBlock as l, openBlock as i, normalizeStyle as G, unref as h, createCommentVNode as u, createElementVNode as r, normalizeClass as C, renderSlot as d, createTextVNode as v, toDisplayString as c, withKeys as k, withModifiers as $, createVNode as H, mergeProps as J, createSlots as O, withCtx as E } from "vue";
import Q from "../button/index.js";
import { useInject as U, useSlotsExist as X } from "../utils/index.js";
const Y = {
  key: 0,
  class: "input-search-prefix"
}, Z = ["value", "placeholder", "maxlength", "disabled", "onKeydown"], _ = {
  key: 1,
  class: "input-search-suffix"
}, ee = {
  key: 1,
  class: "input-search-count"
}, ae = {
  key: 2,
  class: "suffix-item"
}, te = ["onKeydown"], le = /* @__PURE__ */ A({
  __name: "InputSearch",
  props: {
    width: { default: "100%" },
    icon: { type: Boolean, default: !0 },
    search: { default: void 0 },
    searchProps: { default: () => ({}) },
    size: { default: "middle" },
    allowClear: { type: Boolean, default: !1 },
    addonBefore: { default: void 0 },
    prefix: { default: void 0 },
    suffix: { default: void 0 },
    loading: { type: Boolean, default: !1 },
    disabled: { type: Boolean, default: !1 },
    placeholder: { default: void 0 },
    maxlength: { default: void 0 },
    showCount: { type: Boolean, default: !1 },
    value: { default: void 0 },
    valueModifiers: { default: () => ({}) }
  },
  emits: ["update:value", "compositionstart", "compositionend", "change", "search"],
  setup(I, { emit: M }) {
    const a = I, y = w(null), f = w(!1), o = w(), { colorPalettes: b, shadowColor: K } = U("InputSearch"), n = M, m = X(["prefix", "suffix", "addonBefore"]), L = s(() => typeof a.width == "number" ? `${a.width}px` : a.width), B = s(() => !a.disabled && a.allowClear), N = s(() => a.maxlength ? (o.value ? o.value.length : 0) + " / " + a.maxlength : o.value ? o.value.length : 0), P = s(() => m.prefix || a.prefix), S = s(() => m.suffix || a.suffix), V = s(() => B.value || a.showCount || S.value), x = s(() => m.addonBefore || a.addonBefore), z = s(() => "lazy" in a.valueModifiers);
    F(
      () => a.value,
      (e) => {
        o.value !== e && (o.value = e);
      },
      {
        immediate: !0
      }
    );
    function R(e) {
      f.value = !0, n("compositionstart", e);
    }
    function j(e) {
      var p;
      f.value = !1, n("compositionend", e);
      const t = new Event("change");
      (p = e.target) == null || p.dispatchEvent(t);
    }
    function D(e) {
      if (!f.value) {
        const t = e.target;
        o.value = t.value, z.value || (n("update:value", t.value), n("change", e));
      }
    }
    function T(e) {
      const t = e.target;
      t.value !== a.value && (n("update:value", t.value), n("change", e));
    }
    function W() {
      var e;
      o.value = "", n("update:value", ""), (e = y.value) == null || e.focus();
    }
    function q(e) {
      var t;
      if (!(f.value || a.loading) && (g(e), z.value)) {
        const p = new Event("change");
        (t = e.target) == null || t.dispatchEvent(p);
      }
    }
    function g(e) {
      n("search", o.value, e);
    }
    return (e, t) => (i(), l("div", {
      class: "m-input-search",
      style: G(`
      --input-search-width: ${L.value};
      --input-search-primary-color-hover: ${h(b)[4]};
      --input-search-primary-color-focus: ${h(b)[4]};
      --input-search-primary-shadow-color: ${h(K)};
    `)
    }, [
      x.value ? (i(), l("span", {
        key: 0,
        class: C(["input-search-addon-before", `addon-before-${e.size}`])
      }, [
        d(e.$slots, "addonBefore", {}, () => [
          v(c(e.addonBefore), 1)
        ], !0)
      ], 2)) : u("", !0),
      r("div", {
        tabindex: "1",
        class: C(["input-search-wrap", [
          `input-search-${e.size}`,
          {
            "input-search-before": x.value,
            "input-search-disabled": e.disabled
          }
        ]])
      }, [
        P.value ? (i(), l("span", Y, [
          d(e.$slots, "prefix", {}, () => [
            v(c(e.prefix), 1)
          ], !0)
        ])) : u("", !0),
        r("input", {
          ref_key: "inputRef",
          ref: y,
          class: "input-search",
          type: "text",
          value: o.value,
          placeholder: e.placeholder,
          maxlength: e.maxlength,
          disabled: e.disabled,
          onCompositionstart: R,
          onCompositionend: j,
          onInput: D,
          onChange: T,
          onKeydown: k($(q, ["prevent"]), ["enter"])
        }, null, 40, Z),
        V.value ? (i(), l("span", _, [
          B.value ? (i(), l("span", {
            key: 0,
            class: C(["input-search-clear", { "clear-hidden": !o.value }]),
            onClick: W
          }, t[0] || (t[0] = [
            r("svg", {
              class: "clear-svg",
              focusable: "false",
              "data-icon": "close-circle",
              width: "1em",
              height: "1em",
              fill: "currentColor",
              "aria-hidden": "true",
              viewBox: "64 64 896 896"
            }, [
              r("path", { d: "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448 448-200.6 448-448S759.4 64 512 64zm165.4 618.2l-66-.3L512 563.4l-99.3 118.4-66.1.3c-4.4 0-8-3.5-8-8 0-1.9.7-3.7 1.9-5.2l130.1-155L340.5 359a8.32 8.32 0 01-1.9-5.2c0-4.4 3.6-8 8-8l66.1.3L512 464.6l99.3-118.4 66-.3c4.4 0 8 3.5 8 8 0 1.9-.7 3.7-1.9 5.2L553.5 514l130 155c1.2 1.5 1.9 3.3 1.9 5.2 0 4.4-3.6 8-8 8z" })
            ], -1)
          ]), 2)) : u("", !0),
          e.showCount ? (i(), l("span", ee, c(N.value), 1)) : u("", !0),
          S.value ? (i(), l("span", ae, [
            d(e.$slots, "suffix", {}, () => [
              v(c(e.suffix), 1)
            ], !0)
          ])) : u("", !0)
        ])) : u("", !0)
      ], 2),
      r("span", {
        class: "input-search-button",
        onClick: g,
        onKeydown: k($(g, ["prevent"]), ["enter"])
      }, [
        d(e.$slots, "search", {}, () => [
          H(h(Q), J({
            class: "search-btn",
            size: e.size,
            disabled: e.disabled,
            loading: e.loading
          }, e.searchProps), O({
            default: E(() => [
              v(" " + c(e.search), 1)
            ]),
            _: 2
          }, [
            e.icon ? {
              name: "icon",
              fn: E(() => [
                d(e.$slots, "icon", {}, () => [
                  t[1] || (t[1] = r("svg", {
                    focusable: "false",
                    "data-icon": "search",
                    width: "1em",
                    height: "1em",
                    fill: "currentColor",
                    "aria-hidden": "true",
                    viewBox: "64 64 896 896"
                  }, [
                    r("path", { d: "M909.6 854.5L649.9 594.8C690.2 542.7 712 479 712 412c0-80.2-31.3-155.4-87.9-212.1-56.6-56.7-132-87.9-212.1-87.9s-155.5 31.3-212.1 87.9C143.2 256.5 112 331.8 112 412c0 80.1 31.3 155.5 87.9 212.1C256.5 680.8 331.8 712 412 712c67 0 130.6-21.8 182.7-62l259.7 259.6a8.2 8.2 0 0011.6 0l43.6-43.5a8.2 8.2 0 000-11.6zM570.4 570.4C528 612.7 471.8 636 412 636s-116-23.3-158.4-65.6C211.3 528 188 471.8 188 412s23.3-116.1 65.6-158.4C296 211.3 352.2 188 412 188s116.1 23.2 158.4 65.6S636 352.2 636 412s-23.3 116.1-65.6 158.4z" })
                  ], -1))
                ], !0)
              ]),
              key: "0"
            } : void 0
          ]), 1040, ["size", "disabled", "loading"])
        ], !0)
      ], 40, te)
    ], 4));
  }
});
export {
  le as default
};
