import { defineComponent as C, computed as d, createElementBlock as t, openBlock as a, normalizeStyle as p, normalizeClass as o, withDirectives as k, createElementVNode as i, createCommentVNode as l, createStaticVNode as v, renderSlot as m, createTextVNode as w, toDisplayString as S, vShow as b } from "vue";
import { useInject as B, useSlotsExist as P } from "../utils/index.js";
const R = { class: "spin-wrap" }, z = { class: "spin-box" }, E = {
  key: 0,
  class: "spin-loading-dot"
}, N = {
  key: 3,
  class: "spin-ring-circle"
}, V = {
  class: "circle",
  viewBox: "0 0 100 100"
}, W = ["d"], D = {
  key: 4,
  class: "spin-ring-rail"
}, I = {
  class: "circle",
  viewBox: "0 0 100 100"
}, M = ["d", "stroke"], T = ["d"], j = {
  key: 5,
  class: "spin-dynamic-circle"
}, q = {
  key: 6,
  class: "spin-magic-ring"
}, G = /* @__PURE__ */ C({
  __name: "Spin",
  props: {
    spinning: { type: Boolean, default: !0 },
    size: { default: "middle" },
    tip: { default: void 0 },
    indicator: { default: "dot" },
    color: { default: void 0 },
    spinCircleWidth: { default: 12 },
    spinCirclePercent: { default: 33 },
    ringRailColor: { default: "rgba(0, 0, 0, 0.12)" },
    magicRingColor: { default: void 0 },
    rotate: { type: Boolean, default: !1 },
    speed: { default: 800 }
  },
  setup(f) {
    const n = f, { colorPalettes: u } = B("Spin"), g = P(["tip"]), r = d(() => (100 - n.spinCircleWidth) * Math.PI), c = d(() => {
      const s = 100 - n.spinCircleWidth;
      return `M 50,50 m 0,-${s / 2}
   a ${s / 2},${s / 2} 0 1 1 0,${s}
   a ${s / 2},${s / 2} 0 1 1 0,-${s}`;
    }), y = d(() => n.color === void 0 ? u.value[5] : n.color), $ = d(() => n.magicRingColor === void 0 ? u.value[4] : n.magicRingColor), h = d(() => g.tip || n.tip);
    return (s, e) => (a(), t("div", {
      class: o(`m-spin spin-${s.size}`),
      style: p(`
      --spin-primary-color: ${y.value};
      --spin-ring-rail-color: ${s.ringRailColor};
      --spin-magic-ring-color: ${$.value};
      --spin-circle-width: ${s.spinCircleWidth};
      --spin-speed: ${s.speed}ms;
    `)
    }, [
      k(i("div", R, [
        i("div", z, [
          s.indicator === "dot" ? (a(), t("div", E, e[0] || (e[0] = [
            i("span", { class: "dot-item" }, null, -1),
            i("span", { class: "dot-item" }, null, -1),
            i("span", { class: "dot-item" }, null, -1),
            i("span", { class: "dot-item" }, null, -1)
          ]))) : l("", !0),
          s.indicator === "spin-dot" ? (a(), t("div", {
            key: 1,
            class: o(["spin-wrap-box", { "spin-box-rotate": s.rotate }])
          }, [
            e[2] || (e[2] = v('<div class="spin-dot-items" data-v-4391ffea><span class="dot-item" data-v-4391ffea></span><span class="dot-item" data-v-4391ffea></span><span class="dot-item" data-v-4391ffea></span><span class="dot-item" data-v-4391ffea></span></div>', 1)),
            i("div", {
              class: o(["spin-dot-items spin-rotate", { "has-tip": s.tip }])
            }, e[1] || (e[1] = [
              i("span", { class: "dot-item" }, null, -1),
              i("span", { class: "dot-item" }, null, -1),
              i("span", { class: "dot-item" }, null, -1),
              i("span", { class: "dot-item" }, null, -1)
            ]), 2)
          ], 2)) : l("", !0),
          s.indicator === "spin-line" ? (a(), t("div", {
            key: 2,
            class: o(["spin-wrap-box", { "spin-box-rotate": s.rotate }])
          }, [
            e[4] || (e[4] = v('<div class="spin-line-items" data-v-4391ffea><span class="line-item" data-v-4391ffea></span><span class="line-item" data-v-4391ffea></span><span class="line-item" data-v-4391ffea></span><span class="line-item" data-v-4391ffea></span></div>', 1)),
            i("div", {
              class: o(["spin-line-items spin-rotate", { "has-tip": s.tip }])
            }, e[3] || (e[3] = [
              i("span", { class: "line-item" }, null, -1),
              i("span", { class: "line-item" }, null, -1),
              i("span", { class: "line-item" }, null, -1),
              i("span", { class: "line-item" }, null, -1)
            ]), 2)
          ], 2)) : l("", !0),
          s.indicator === "ring-circle" ? (a(), t("div", N, [
            (a(), t("svg", V, [
              i("path", {
                d: c.value,
                "stroke-linecap": "round",
                class: "path",
                style: p(`stroke-dasharray: ${s.spinCirclePercent / 100 * r.value}px, ${r.value}px;`),
                "fill-opacity": "0"
              }, null, 12, W)
            ]))
          ])) : l("", !0),
          s.indicator === "ring-rail" ? (a(), t("div", D, [
            (a(), t("svg", I, [
              i("path", {
                d: c.value,
                stroke: s.ringRailColor,
                "stroke-linecap": "round",
                class: "trail",
                style: p(`stroke-dasharray: ${r.value}px, ${r.value}px;`),
                "fill-opacity": "0"
              }, null, 12, M),
              i("path", {
                d: c.value,
                "stroke-linecap": "round",
                class: "path",
                style: p(`stroke-dasharray: ${s.spinCirclePercent / 100 * r.value}px, ${r.value}px;`),
                "fill-opacity": "0"
              }, null, 12, T)
            ]))
          ])) : l("", !0),
          s.indicator === "dynamic-circle" ? (a(), t("div", j, e[5] || (e[5] = [
            i("svg", {
              class: "circle",
              viewBox: "0 0 50 50"
            }, [
              i("circle", {
                class: "path",
                cx: "25",
                cy: "25",
                r: "20",
                fill: "none"
              })
            ], -1)
          ]))) : l("", !0),
          s.indicator === "magic-ring" ? (a(), t("div", q, e[6] || (e[6] = [
            i("div", { class: "outer-ring" }, null, -1),
            i("div", { class: "inner-ring" }, null, -1)
          ]))) : l("", !0),
          h.value ? (a(), t("div", {
            key: 7,
            class: o(["spin-tip", { "dot-tip": ["dot", "spin-dot"].includes(s.indicator) }])
          }, [
            m(s.$slots, "tip", {}, () => [
              w(S(s.tip), 1)
            ], !0)
          ], 2)) : l("", !0)
        ])
      ], 512), [
        [b, s.spinning]
      ]),
      i("div", {
        class: o(["spin-content", { "spin-blur": s.spinning }])
      }, [
        m(s.$slots, "default", {}, void 0, !0)
      ], 2)
    ], 6));
  }
});
export {
  G as default
};
