import { defineComponent as ie, ref as o, computed as v, watch as re, onMounted as ve, createElementBlock as p, openBlock as f, normalizeStyle as c, normalizeClass as g, unref as fe, createElementVNode as S, createCommentVNode as L, renderSlot as H, createTextVNode as K, toDisplayString as T, Fragment as E, renderList as X, createBlock as ce, resolveDynamicComponent as de } from "vue";
import { useInject as be, useSlotsExist as pe, useResizeObserver as ye } from "../utils/index.js";
const me = {
  key: 0,
  class: "tabs-prefix"
}, he = ["onClick"], ge = {
  key: 1,
  class: "tabs-suffix"
}, $e = /* @__PURE__ */ ie({
  __name: "Tabs",
  props: {
    items: { default: () => [] },
    prefix: { default: void 0 },
    suffix: { default: void 0 },
    animated: { type: Boolean, default: !0 },
    centered: { type: Boolean, default: !1 },
    size: { default: "middle" },
    type: { default: "line" },
    tabGutter: { default: void 0 },
    tabStyle: { default: () => ({}) },
    tabPosition: { default: "top" },
    contentStyle: { default: () => ({}) },
    activeKey: { default: void 0 }
  },
  emits: ["update:activeKey", "change"],
  setup(x, { emit: I }) {
    const l = x, W = o(), y = o(0), m = o(0), k = o(0), w = o(0), $ = o(), P = o(), B = o(), z = o(), C = o(), R = o(), u = o(!1), i = o(0), s = o(0), n = o(0), h = o(!1), { colorPalettes: M } = be("Tabs"), N = I, V = pe(["prefix", "suffix"]), d = v(() => l.items.findIndex((e, t) => b(e.key, t) === l.activeKey)), j = v(() => !!(V.prefix || l.prefix)), F = v(() => !!(V.suffix || l.suffix)), O = v(() => ["top", "bottom"].includes(l.tabPosition) ? u.value && s.value > 0 : u.value && n.value > 0), q = v(() => ["top", "bottom"].includes(l.tabPosition) ? u.value && s.value < i.value : u.value && n.value < i.value), A = v(() => ["top", "bottom"].includes(l.tabPosition) ? {
      transform: `translate(${-s.value}px, 0)`
    } : {
      transform: `translate(0, ${-n.value}px)`
    }), J = v(() => ["top", "bottom"].includes(l.tabPosition) ? {
      marginLeft: `${l.tabGutter}px`
    } : {
      marginTop: `${l.tabGutter}px`
    }), Q = v(() => ["top", "bottom"].includes(l.tabPosition) ? {
      left: `${y.value}px`,
      width: `${k.value}px`
    } : {
      top: `${m.value}px`,
      height: `${w.value}px`
    }), U = v(() => l.animated && ["top", "bottom"].includes(l.tabPosition) ? {
      marginLeft: `-${100 * (d.value !== -1 ? d.value : 0)}%`
    } : {}), Z = v(() => l.animated && ["top", "bottom"].includes(l.tabPosition) ? {
      visibility: "hidden",
      height: "0px",
      overflowY: "hidden"
    } : {
      display: "none"
    });
    re(
      () => l.activeKey,
      () => {
        D();
      },
      {
        flush: "post"
      }
    ), ve(() => {
      G();
    }), ye([$, z], () => {
      G();
    });
    function G() {
      ["top", "bottom"].includes(l.tabPosition) ? _() : ee();
    }
    function _() {
      P.value = $.value.offsetWidth, C.value = z.value.offsetWidth, C.value > P.value ? (u.value = !0, i.value = C.value - P.value, s.value = i.value) : (u.value = !1, s.value = 0), D();
    }
    function ee() {
      B.value = $.value.offsetHeight, R.value = z.value.offsetHeight, R.value > B.value ? (u.value = !0, i.value = R.value - B.value, n.value = i.value) : (u.value = !1, n.value = 0), D();
    }
    function D() {
      ["top", "bottom"].includes(l.tabPosition) ? te() : ae();
    }
    function te() {
      const e = d.value !== -1 ? W.value[d.value] : null;
      if (e) {
        if (y.value = e.offsetLeft, k.value = e.offsetWidth, u.value) {
          y.value < s.value && (h.value = !0, s.value = y.value);
          const t = y.value + k.value - P.value;
          t > s.value && (h.value = !0, s.value = t);
        }
      } else
        y.value = 0, k.value = 0;
    }
    function ae() {
      const e = d.value !== -1 ? W.value[d.value] : null;
      if (e) {
        if (m.value = e.offsetTop, w.value = e.offsetHeight, u.value) {
          m.value < n.value && (h.value = !0, n.value = m.value);
          const t = m.value + w.value - B.value;
          t > n.value && (h.value = !0, n.value = t);
        }
      } else
        m.value = 0, w.value = 0;
    }
    function b(e, t) {
      return e === void 0 ? t : e;
    }
    function le(e) {
      N("update:activeKey", e), N("change", e);
    }
    function oe(e) {
      e.stopPropagation(), e.preventDefault(), (e.deltaX || e.deltaY) && (["top", "bottom"].includes(l.tabPosition) ? se(e) : ne(e));
    }
    function se(e) {
      const t = (e.deltaX || e.deltaY) * 1;
      s.value + t > i.value ? s.value = i.value : s.value + t < 0 ? s.value = 0 : s.value += t;
    }
    function ne(e) {
      const t = (e.deltaX || e.deltaY) * 1;
      n.value + t > i.value ? n.value = i.value : n.value + t < 0 ? n.value = 0 : n.value += t;
    }
    function ue(e, t) {
      return l.activeKey !== b(e, t) ? Z.value : {};
    }
    return (e, t) => {
      var Y;
      return f(), p("div", {
        class: g(["m-tabs", [
          `tabs-${e.tabPosition} tabs-${e.size}`,
          {
            "tabs-card": e.type === "card"
          }
        ]]),
        style: c(`--tabs-primary-color: ${fe(M)[5]};`)
      }, [
        S("div", {
          class: "m-tabs-nav",
          style: c(e.tabStyle)
        }, [
          j.value ? (f(), p("div", me, [
            H(e.$slots, "prefix", {}, () => [
              K(T(e.prefix), 1)
            ], !0)
          ])) : L("", !0),
          S("div", {
            ref_key: "wrapRef",
            ref: $,
            class: g(["tabs-nav-wrap", {
              "tabs-center": e.centered,
              "before-shadow-active": O.value,
              "after-shadow-active": q.value
            }])
          }, [
            S("div", {
              ref_key: "navRef",
              ref: z,
              class: g(["tabs-nav-list", { "nav-transition": h.value }]),
              onTransitionend: t[0] || (t[0] = (a) => h.value = !1),
              style: c(A.value),
              onWheel: t[1] || (t[1] = (a) => u.value ? oe(a) : () => !1)
            }, [
              (f(!0), p(E, null, X(e.items, (a, r) => (f(), p("div", {
                ref_for: !0,
                ref_key: "tabsRef",
                ref: W,
                class: g(["tab-item", {
                  "tab-line-active": e.type === "line" && e.activeKey === b(a.key, r),
                  "tab-card-active": e.type === "card" && e.activeKey === b(a.key, r),
                  "tab-disabled": a.disabled
                }]),
                style: c(r > 0 && e.tabGutter !== void 0 ? J.value : {}),
                onClick: (Se) => a.disabled ? () => !1 : le(b(a.key, r)),
                key: r
              }, [
                H(e.$slots, "tab", {
                  item: a,
                  tab: a.tab,
                  key: b(a.key, r)
                }, () => [
                  a.icon ? (f(), ce(de(a.icon), { key: 0 })) : L("", !0),
                  K(" " + T(a.tab), 1)
                ], !0)
              ], 14, he))), 128)),
              S("div", {
                class: g(["tab-bar", {
                  "tab-bar-disabled": (Y = e.items[d.value]) == null ? void 0 : Y.disabled,
                  "card-hidden": e.type === "card"
                }]),
                style: c(Q.value)
              }, null, 6)
            ], 38)
          ], 2),
          F.value ? (f(), p("div", ge, [
            H(e.$slots, "suffix", {}, () => [
              K(T(e.suffix), 1)
            ], !0)
          ])) : L("", !0)
        ], 4),
        S("div", {
          class: "m-tabs-page",
          style: c(e.contentStyle)
        }, [
          S("div", {
            class: g(["tabs-content-wrap", { "tabs-content-animated": e.animated && ["top", "bottom"].includes(e.tabPosition) }]),
            style: c(U.value)
          }, [
            (f(!0), p(E, null, X(e.items, (a, r) => (f(), p("div", {
              class: "tabs-content",
              style: c(ue(a.key, r)),
              key: a.key || r
            }, [
              H(e.$slots, "content", {
                item: a,
                content: a.content,
                key: b(a.key, r)
              }, () => [
                K(T(a.content), 1)
              ], !0)
            ], 4))), 128))
          ], 6)
        ], 4)
      ], 6);
    };
  }
});
export {
  $e as default
};
