import { onMounted as Y, onUnmounted as U, ref as d, computed as h, toValue as w, watch as A, onBeforeUnmount as E, useSlots as j, reactive as H, inject as T, toRefs as O, getCurrentInstance as k, Comment as q, Text as B } from "vue";
import { TinyColor as S } from "@ctrl/tinycolor";
import { generate as P } from "@ant-design/colors";
function X(e = Date.now(), n = "YYYY-MM-DD HH:mm:ss") {
  try {
    let t;
    if (typeof e == "number" || typeof e == "string") {
      if (t = new Date(e), isNaN(t.getTime()))
        throw new Error("Invalid date");
    } else
      t = e;
    const r = (u, s = 2) => String(u).padStart(s, "0"), o = (u) => {
      switch (u) {
        case "YYYY":
          return r(t.getFullYear());
        case "YY":
          return r(t.getFullYear()).slice(2, 4);
        case "MM":
          return r(t.getMonth() + 1);
        case "M":
          return String(t.getMonth() + 1);
        case "DD":
          return r(t.getDate());
        case "D":
          return String(t.getDate());
        case "HH":
          return r(t.getHours());
        case "H":
          return String(t.getHours());
        case "mm":
          return r(t.getMinutes());
        case "m":
          return String(t.getMinutes());
        case "ss":
          return r(t.getSeconds());
        case "s":
          return String(t.getSeconds());
        case "SSS":
          return r(t.getMilliseconds(), 3);
        default:
          return u;
      }
    };
    return n.replace(/(YYYY|YY|M{1,2}|D{1,2}|H{1,2}|m{1,2}|s{1,2}|SSS)/g, o);
  } catch (t) {
    return console.error("Error formatting date:", t), "";
  }
}
function _(e, n = 2, t = ",", r = ".", o, u) {
  typeof e != "number" && typeof e != "string" && console.warn("Expected value to be of type number or string"), typeof n != "number" && console.warn("Expected precision to be of type number");
  const s = Number(e);
  if (isNaN(s) || !isFinite(s))
    return "";
  if (s === 0)
    return s.toFixed(n);
  let c = s.toFixed(n);
  if (typeof t == "string" && t !== "") {
    const [a, i] = c.split(".");
    c = a.replace(/(\d)(?=(\d{3})+$)/g, "$1" + t) + (i ? r + i : "");
  }
  return (o || "") + c + (u || "");
}
function Q(e, n = 0, t = !1) {
  let r = null;
  function o(s) {
    if (r || (r = s), s - r >= n) {
      try {
        e();
      } catch (a) {
        console.error("Error executing rafTimeout function:", a);
      }
      t && (r = s, u.id = requestAnimationFrame(o));
    } else
      u.id = requestAnimationFrame(o);
  }
  const u = {
    id: requestAnimationFrame(o)
  };
  return u;
}
function ee(e) {
  e && e.id && typeof e.id == "number" ? cancelAnimationFrame(e.id) : console.warn("cancelRaf received an invalid id:", e);
}
function C(e, n = 300) {
  let t = !0;
  return function(...r) {
    if (!t) return !1;
    t && (e(...r), t = !1, setTimeout(() => {
      t = !0;
    }, n));
  };
}
function z(e, n = 300) {
  let t = null;
  return function(...r) {
    t && clearTimeout(t), t = setTimeout(() => {
      e(...r);
    }, n);
  };
}
function te(e, n) {
  if (Number.isNaN(e) || Number.isNaN(n))
    throw new Error("Both num1 and num2 must be valid numbers.");
  const t = e % 1 !== 0, r = n % 1 !== 0;
  if (!t && !r)
    return e + n;
  const o = String(e).split(".")[1] ?? "", u = String(n).split(".")[1] ?? "", s = Math.max(o.length, u.length), c = Math.pow(10, s), a = e.toFixed(s), i = n.toFixed(s);
  return (+a.replace(".", "") + +i.replace(".", "")) / c;
}
function ne(e, n) {
  if (!e) {
    console.error("无效的 url");
    return;
  }
  const t = n || e.split("?")[0].split("/").pop() || "download";
  try {
    fetch(e).then((r) => {
      r.ok ? r.blob().then((o) => {
        const u = URL.createObjectURL(o), s = document.createElement("a");
        s.href = u, s.download = t, document.body.appendChild(s), s.click(), document.body.removeChild(s), URL.revokeObjectURL(u);
      }) : console.error("请求文件失败，状态码:", r.status);
    });
  } catch (r) {
    console.error("文件下载失败:", r);
  }
}
function re() {
  const e = document.documentElement;
  e.classList.toggle("dark"), e.classList.contains("dark") ? e.style.colorScheme = "dark" : e.style.colorScheme = "light";
}
function G() {
  const e = d(!1), n = k();
  return n && Y(() => {
    e.value = !0;
  }, n), e;
}
function N(e) {
  const n = G();
  return h(() => (n.value, !!e()));
}
function oe(e, n, t) {
  Y(() => e.addEventListener(n, t)), U(() => e.removeEventListener(n, t));
}
function se(e, n, t = {}) {
  const r = N(() => window && "MutationObserver" in window), o = d(!1);
  let u;
  const s = h(() => {
    const f = w(e);
    return f ? Array.isArray(f) ? f.map((m) => w(m)).filter((m) => m) : [f] : [];
  }), c = () => {
    u && (u.disconnect(), u = void 0);
  }, a = () => {
    r.value && s.value.length && !o.value && (u = new MutationObserver(n), s.value.forEach((f) => u.observe(f, t)));
  };
  A(
    () => s.value,
    () => {
      c(), a();
    },
    {
      immediate: !0,
      // 立即触发回调，以便初始状态也被观察
      flush: "post"
    }
  );
  const i = () => {
    o.value = !1, a();
  }, v = () => {
    o.value = !0, c();
  };
  return E(() => c()), {
    start: i,
    stop: v
  };
}
function ue(e = window, n = 0, t, r) {
  const o = d(0), u = d(0), s = d(0), c = d(0), a = d(!1), i = d(!1), v = d(!1), f = d(!1), m = d(!1), y = d(0), M = d(0);
  function V(l) {
    a.value = !0;
    const p = l.target.documentElement ?? l.target;
    o.value = p.scrollLeft, s.value = p.scrollTop, i.value = o.value < y.value, v.value = o.value > y.value, f.value = s.value < M.value, m.value = s.value > M.value, y.value = o.value, M.value = s.value, L(l), t && t(l);
  }
  const F = C(V, n);
  function I(l) {
    a.value && (a.value = !1, i.value = !1, v.value = !1, f.value = !1, m.value = !1, r && r(l));
  }
  const L = z(I, n + 200), R = h(() => {
    const l = w(e);
    return l || null;
  });
  A(
    () => R.value,
    (l, p) => {
      var b;
      if (p && D(p), l) {
        const g = ((b = l == null ? void 0 : l.document) == null ? void 0 : b.documentElement) || (l == null ? void 0 : l.documentElement) || l;
        u.value = g.scrollWidth - g.clientWidth, c.value = g.scrollHeight - g.clientHeight, g.addEventListener("scroll", F), g.addEventListener("scrollend", L);
      }
    },
    {
      immediate: !0,
      flush: "post"
    }
  );
  function D(l) {
    var b;
    const p = ((b = l == null ? void 0 : l.document) == null ? void 0 : b.documentElement) || (l == null ? void 0 : l.documentElement) || l;
    p.removeEventListener("scroll", F), p.removeEventListener("scrollend", L);
  }
  return E(() => D(R.value)), { x: o, xScrollMax: u, y: s, yScrollMax: c, isScrolling: a, left: i, right: v, top: f, bottom: m };
}
function ce() {
  const e = d(0), n = d(0);
  let t = performance.now();
  const r = 10, o = (u) => {
    if (n.value++, n.value >= r) {
      const s = u - t;
      e.value = Math.round(1e3 / (s / r)), t = u, n.value = 0;
    }
    requestAnimationFrame(o);
  };
  return requestAnimationFrame(o), { fps: e };
}
function le(e) {
  if (!e || typeof e != "string" || e.trim() === "")
    throw new Error("Invalid mediaQuery parameter. It must be a non-empty string.");
  const n = d(window && window.matchMedia(e).matches), t = window.matchMedia(e), r = (o) => {
    n.value = o.matches;
  };
  return Y(() => {
    t.addEventListener("change", r);
  }), E(() => {
    t.removeEventListener("change", r);
  }), { match: n };
}
function ie(e, n, t = {}) {
  const r = N(() => window && "ResizeObserver" in window);
  let o;
  const u = d(!1), s = h(() => {
    const f = w(e);
    return f ? Array.isArray(f) ? f.map((m) => w(m)).filter((m) => m) : [f] : [];
  }), c = () => {
    o && (o.disconnect(), o = void 0);
  }, a = () => {
    r.value && s.value.length && !u.value && (o = new ResizeObserver(n), s.value.forEach((f) => o.observe(f, t)));
  };
  A(
    () => s.value,
    () => {
      c(), a();
    },
    {
      immediate: !0,
      // 立即触发回调，以便初始状态也被观察
      flush: "post"
    }
  );
  const i = () => {
    u.value = !1, a();
  }, v = () => {
    u.value = !0, c();
  };
  return E(() => c()), {
    start: i,
    stop: v
  };
}
function ae(e) {
  const n = j(), t = (r) => {
    var s;
    const o = (s = n[r]) == null ? void 0 : s.call(n), u = (c) => {
      if (c.type === q || Array.isArray(c.children) && !c.children.length)
        return !1;
      if (c.type !== B)
        return !0;
      if (typeof c.children == "string")
        return c.children.trim() !== "";
    };
    return o && (o != null && o.length) ? o.some((a) => u(a)) : !1;
  };
  if (Array.isArray(e)) {
    const r = H({});
    return e.forEach((o) => {
      const u = h(() => t(o));
      r[o] = u;
    }), r;
  } else
    return h(() => t(e));
}
function fe(e) {
  const n = W("#1677ff"), t = T("common", H({ colorPalettes: n, shadowColor: $(n[0]) })), r = T("components", null);
  return r !== null && e in r && r[e].colorPalettes.length ? O(r[e]) : O(t);
}
function W(e) {
  return P(e);
}
function x(e) {
  return e >= 0 && e <= 255;
}
function $(e, n = "#ffffff") {
  const { r: t, g: r, b: o, a: u } = new S(e).toRgb();
  if (u < 1) return e;
  const { r: s, g: c, b: a } = new S(n).toRgb();
  for (let i = 0.01; i <= 1; i += 0.01) {
    const v = Math.round((t - s * (1 - i)) / i), f = Math.round((r - c * (1 - i)) / i), m = Math.round((o - a * (1 - i)) / i);
    if (x(v) && x(f) && x(m))
      return new S({ r: v, g: f, b: m, a: Math.round(i * 100) / 100 }).toRgbString();
  }
  return new S({ r: t, g: r, b: o, a: 1 }).toRgbString();
}
function de(e) {
  const n = d(!1);
  try {
    const t = {
      get [e]() {
        return n.value = !0, !1;
      }
    };
    window.addEventListener("test", () => null, t), window.removeEventListener("test", () => null, t);
  } catch {
    n.value = !1;
  }
  return { isSupported: n };
}
export {
  te as add,
  ee as cancelRaf,
  X as dateFormat,
  z as debounce,
  ne as downloadFile,
  _ as formatNumber,
  $ as getAlphaColor,
  W as getColorPalettes,
  Q as rafTimeout,
  C as throttle,
  re as toggleDark,
  oe as useEventListener,
  ce as useFps,
  fe as useInject,
  le as useMediaQuery,
  G as useMounted,
  se as useMutationObserver,
  de as useOptionsSupported,
  ie as useResizeObserver,
  ue as useScroll,
  ae as useSlotsExist,
  N as useSupported
};
