import { CSSProperties } from 'vue';
export interface Item {
    title: string;
    href?: string;
    target?: '_self' | '_blank';
}
export interface Props {
    items?: Item[] | Item;
    single?: boolean;
    width?: number | string;
    height?: number;
    itemStyle?: CSSProperties;
    hrefHoverColor?: string;
    amount?: number;
    gap?: number;
    speed?: number;
    vertical?: boolean;
    duration?: number;
    interval?: number;
    pauseOnMouseEnter?: boolean;
}
declare function startMove(): void;
declare function stopMove(): void;
declare function resetMove(): void;
declare const _default: import('vue').DefineComponent<Props, {
    start: typeof startMove;
    stop: typeof stopMove;
    reset: typeof resetMove;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    click: (...args: any[]) => void;
}, string, import('vue').PublicProps, Readonly<Props> & Readonly<{
    onClick?: ((...args: any[]) => any) | undefined;
}>, {
    duration: number;
    width: number | string;
    height: number;
    vertical: boolean;
    single: boolean;
    gap: number;
    speed: number;
    pauseOnMouseEnter: boolean;
    interval: number;
    items: Item[] | Item;
    itemStyle: CSSProperties;
    hrefHoverColor: string;
    amount: number;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {
    horizontalRef: HTMLDivElement;
    groupRef: HTMLDivElement;
    verticalRef: HTMLDivElement;
}, any>;
export default _default;
